<?php

/**************************************************************************
nmidCreatePDF Functions
**************************************************************************/

/**
 * Graph retrieval function
 * @param string $s_password
 * @param string $i_lgid
 * @param string $i_start
 * @param string $i_end
 * @param string $i_height
 * @param string $i_width
 * @return string
 */
function getReportList( $s_password,$i_lgid,$i_start,$i_end,$i_height,$i_width )
{
    if  ( checkPassword( $s_password )  )
    {
        $s_reportList = '';
        $s_query = "
        SELECT
          `plugin_nmidCreatePDF_Reports`.`ReportId`,
          `plugin_nmidCreatePDF_Reports`.`Name`,
          `plugin_nmidCreatePDF_Reports`.`reportType`,
          `plugin_nmidCreatePDF_Reports`.`Description` as Description,
          `plugin_nmidCreatePDF_Reports_Types`.`Description` as type
        FROM
          `plugin_nmidCreatePDF_Reports` INNER JOIN
          `plugin_nmidCreatePDF_Reports_Types` ON `plugin_nmidCreatePDF_Reports`.`type`
            = `plugin_nmidCreatePDF_Reports_Types`.`TypeId`
        WHERE
          `plugin_nmidCreatePDF_Reports`.`reportType` = 1";
        /*
        OR
          `plugin_nmidCreatePDF_Reports`.`reportType` = 3;
         ";
        */

        $o_result = mysql_query( $s_query );
        while ( $a_row = mysql_fetch_assoc( $o_result ) ) {
                $s_reportList = $s_reportList .
                        $a_row['ReportId'].';'.
                        $a_row['Name'].
                        "\n";
        }

        // Remove the last newlince char
        $s_reportList = preg_replace("/\n$/","",$s_reportList);

        // Free the result set
        mysql_free_result( $o_result );

        // Return the list of reports
        return $s_reportList;
    }
    else
    {
        return "Error: Wrong WebService Password";
    }
}


/**
 * Graph retrieval function
 * @param string $s_password
 * @param string $i_lgid
 * @param string $i_reportId
 * @return string
 */
function addGraphToReport( $s_password,$i_lgid,$i_reportId )
{
    $s_password = getTextEscaped( $s_password );
    $i_lgid = getNumber( $i_lgid );
    $i_reportId = getNumber( $i_reportId );


    if  ( checkPassword( $s_password )  )
    {
                // Check if the lgid and reportId are valid numbers
                if ( isNumber( $i_lgid ) && isNumber( $i_reportId ) )
                {
                        // get the current max order number, so we can add
                        // the graph to the end of the report
                        $i_current_order_max = getDBValue("maxOrder","select MAX(`order`) as maxOrder from plugin_nmidCreatePDF_GraphReports where ReportId=".$i_reportId);

                        // if the current order max is not set, then the report is
                        // empty and we add the graph to the top of the report
                        if ( !( isset( $i_current_order_max ) ) ) {
                                $i_current_order_max = 0;
                        }

                        // current_order_max contains the value of the last valid graph
                        // in the report( 0 means no graph yet ) so we need to add 1 to it
                        $i_current_order_max = $i_current_order_max + 1;

                        // Now we can finally add the graph to the report
                        mysql_query("INSERT INTO `plugin_nmidCreatePDF_GraphReports` (`ReportId`, `local_graph_id`,`Description`,`order`) VALUES ('$i_reportId', '$i_lgid','','$i_current_order_max')");
                }
                else
                {
                   return 'Error: Invalid input: Not a number.';
                }
    }
    else
    {
                return 'Error: Wrong WebService Password';
    }
}


// Retrieve the nmidCreatePDF Logo
function getCreatePDFLogo ( $password )
{
    if ( checkPassword( $password ) )
    {
        return readConfigOption('nmid_pdflogo') ;
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}

// Retrieve the nmidCreatePDF PageSize
function getCreatePDFPageSize ( $password )
{
    if ( checkPassword( $password ) )
    {
        return readConfigOption('nmid_pdfpagesize') ;
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}

// Retrieve the nmidCreatePDF Footer
function getCreatePDFFooter ( $password )
{
    if ( checkPassword( $password ) )
    {
        return readConfigOption('nmid_pdffooter') ;
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}


?>
