<?php
/*******************************************************************************

    Author ......... Thomas Urban
    Contact ........ nmid@urban-software.de
*******************************************************************************/

function plugin_init_nmidWebService() {
	global $plugin_hooks;
	$plugin_hooks['config_settings']['nmidWebService'] = 'nmidWebService_config_settings';
}


function plugin_nmidWebService_install () {
	// Hooks
	api_plugin_register_hook('nmidWebService', 'config_settings', 'nmidWebService_config_settings', 'setup.php');
        api_plugin_register_hook('nmidWebService', 'config_form', 'nmidWebService_config_form','setup.php');
	api_plugin_register_hook('nmidWebService', 'user_admin_setup_sql_save', 'nmidWebService_api_user_save','setup.php');
	api_plugin_register_hook('nmidWebService', 'poller_bottom', 'nmidWebService_check_mobileSessions', 'setup.php');

	// Realms
	api_plugin_register_realm('nmidWebService','webservice.php', 'NMID - Allow Mobile Client Access',299);
        
	nmidWebService_setup_table_new ();
}

function nmidWebService_check_mobileSessions() {
    global $config, $database_type, $database_default,$database_hostname,$database_username,$database_password,$database_port;
    include_once($config["library_path"] . "/database.php");
    $timeout = time() - ( 60 * read_config_option("nmid_ws_mobiletimeout") ); 
    $sql = 'DELETE FROM plugin_nmidWebService_Mobile_Sessions WHERE lastseen < '.$timeout;
    db_execute($sql);
}

function nmidWebService_config_form() {
	global $fields_user_user_edit_host;
        $fields_user_user_edit_host_2 = $fields_user_user_edit_host;
	$fields_user_user_edit_host_3 = array();
	foreach ($fields_user_user_edit_host_2 as $f => $a) {
		$fields_user_user_edit_host_3[$f] = $a;
		if ( $f == 'realm' ) {
			$fields_user_user_edit_host_3['nmidclient_mobiletoken'] = array(
                		"method" => "textbox_password",
	        	        "friendly_name" => "Mobile Token",
		                "description" => "A unique token which can be used to authenticate against this server using the nmidClient mobile app.",
        	        	"value" => "|arg1:nmidclient_mobiletoken|",
        		        "max_length" => "255"
	                );
		        $fields_user_user_edit_host_3['nmidclient_authmethod'] = array(
		                "friendly_name" => "Mobile Authentication used",
                		"description" => "The method used to authenticate this user",
		                "method" => "drop_array",
                		"default" => "cacti",
				"value" => "|arg1:nmidclient_authmethod|",
		                "array" => array(
                		    "cacti" => "Cacti",
				    "mobiletoken" => "MobileToken"
//				    "cacti_and_mobiletoken" => "Cacti AND MobileToken"
		                )
                	);
		}

	}
	$fields_user_user_edit_host = $fields_user_user_edit_host_3;
}

function nmidWebService_api_user_save ($save) {
        global $database_default, $database_type, $database_port, $database_password, $database_username, $database_hostname, $config;
        if (is_error_message()) {
                return $save;
        }

        if (isset($_POST['nmidclient_mobiletoken'])) {
                $save["nmidclient_mobiletoken"] = form_input_validate($_POST['nmidclient_mobiletoken'], "nmidclient_mobiletoken", "", true, 3);
        } else {
                $save['nmidclient_mobiletoken'] = form_input_validate('', "nmidclient_mobiletoken", "", true, 3);
	}

	if (isset($_POST['nmidclient_authmethod'])) {
                $save["nmidclient_authmethod"] = form_input_validate($_POST['nmidclient_authmethod'], "nmidclient_authmethod", "", true, 3);
        } else {
                $save['nmidclient_authmethod'] = form_input_validate('', "nmidclient_authmethod", "", true, 3);
        }


	return $save;
}

function plugin_nmidWebService_uninstall () {
	// Do any extra Uninstall stuff here
}

function plugin_nmidWebService_check_config () {
	// Here we will check to ensure everything is configured
	nmidWebService_check_upgrade();

	return true;
}

function plugin_nmidWebService_upgrade () {
	// Here we will upgrade to the newest version
	nmidWebService_check_upgrade ();
	return false;
}

function plugin_nmidWebService_version () {
	return nmidWebService_version();
}

function nmidWebService_check_upgrade () {
}

function nmidWebService_check_dependencies() {
	global $plugins, $config;
	return true;
}


function nmidWebService_setup_table_new () {
    global $config, $database_default;
    include_once($config["library_path"] . "/database.php");

    // Check if the nmidWebService tables are present
    $s_sql	= 'show tables from `' . $database_default . '`';
    $result = db_fetch_assoc( $s_sql ) or die ( mysql_error() );
    $a_tables = array();
    $sql 	= array();

    foreach($result as $index => $array) {
	    foreach($array as $table) {
		    $a_tables[] = $table;
	    }
    }

    if (!in_array('plugin_nmidWebService_Mobile_Sessions', $a_tables)) {
 	// Create Report Archive Table
	$data = array();
	$data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
	$data['columns'][] = array('name' => 'UserId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
	$data['columns'][] = array('name' => 'Sessionkey', 'type' => 'text', 'NULL' => true);
        $data['columns'][] = array('name' => 'lastseen', 'type' => 'bigint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
	$data['primary'] = 'Id';
	$data['keys'][] = array('name' => 'Id',	'columns' => 'Id');
	$data['type'] = 'MyISAM';
	$data['comment'] = 'nmidWebService Mobile Session List';
	api_plugin_db_table_create ('nmidWebService', 'plugin_nmidWebService_Mobile_Sessions', $data);	
    }

    if (!in_array('plugin_nmidWebService_Mobile_Favourites', $a_tables)) {
        // Create Mobile Favourites List
        $data = array();
        $data['columns'][] = array('name' => 'Id', 'type' => 'mediumint(25)', 'unsigned' => 'unsigned', 'NULL' => false, 'auto_increment' => true);
        $data['columns'][] = array('name' => 'UserId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
        $data['columns'][] = array('name' => 'graphId', 'type' => 'mediumint(25)','unsigned' => 'unsigned', 'NULL' => false, 'default' => '0');
        $data['primary'] = 'Id';
        $data['keys'][] = array('name' => 'Id', 'columns' => 'Id');
        $data['type'] = 'MyISAM';
        $data['comment'] = 'nmidWebService Mobile Favourites List';
        api_plugin_db_table_create ('nmidWebService', 'plugin_nmidWebService_Mobile_Favourites', $data);
    }

    $data = array();
    $data['name'] = 'nmidclient_mobiletoken';
    $data['type'] = 'varchar(1024)';
    $data['NULL'] = false;
    $data['default'] = '';
    api_plugin_db_add_column ('nmidWebService', 'user_auth', $data);	

    $data = array();
    $data['name'] = 'nmidclient_authmethod';
    $data['type'] = 'varchar(1024)';
    $data['NULL'] = false;
    $data['default'] = '';
    api_plugin_db_add_column ('nmidWebService', 'user_auth', $data);

    // Create Session Table


}

function nmidWebService_config_settings () {
	global $tabs, $settings;
	$tabs["nmid"] = "NMID";

	$temp = array(
		"nmid_webservice" => array(
			"friendly_name" => "NMID - WebService",
			"method" => "spacer",
			),
		"nmid_wspassword" => array(
			"friendly_name" => "WebService Password",
			"description" => "Password used to connect to the webservice",
			"method" => "textbox_password",
			"max_length" => 255,
			),
		"nmid_wsserver" => array(
			"friendly_name" => "Cacti Server",
			"description" => "http://example.com/cacti/",
			"method" => "textbox",
			"max_length" => 255,
			),
		"nmid_ws_mobiletimeout" => array(
                "friendly_name" => "Mobile Session Inactivity Timout",
                "description" => "The time which a mobile session needs to be idle in order to be considered as not being used any more.",
                "method" => "drop_array",
                "default" => "5",
                "array" => array(
                    "5" => "5 Minutes",
                    "10" => "10 Minutes",
		    "15" => "15 Minutes",
		    "30" => "30 Minutes"
                    )
                )
	);

	if (isset($settings["nmid"]))
		$settings["nmid"] = array_merge($settings["nmid"], $temp);
	else
		$settings["nmid"] = $temp;
}

function nmidWebService_version () {
	return array( 'name' 	=> 'nmidWebService',
			'version' 	=> '2.08',
			'longname'	=> 'NMID WebService Plugin',
			'author'	=> 'Thomas Urban',
			'homepage'	=> 'http://www.urban-software.de',
			'email'		=> 'nmid@urban-software.de',
			'url'		=> 'http://www.urban-software.de/nmid/wbservice/versions.php'
			);
}

?>
