<?php

/**************************************************************************
nmidSmokeping Functions
**************************************************************************/

/**
 * Graph retrieval function
 * 
 * @param string $s_password
 * @param string $i_lgid
 * @param string $i_reportId
 * @return string
 */
function getSmokePingGraph($s_password,$i_lgid,$i_reportId)
{
    if ( checkPassword( $s_password ) )
    {
        if ( file_exists('getSmokePingPath') ) {
            $isSmokepingEnabled = readPluginStatus('nmidSmokeping') || FALSE;
            if ( $isSmokepingEnabled ) {
                if ( isNumber( $spid ) ) {
                    $isHostEnabled = getDBValue( 'nwmgmt_settings',"select nwmgmt_settings from host where id=".$spid );
                    if ( preg_match("/^s1/",$isHostEnabled) == 1 ) {
                        $title = getDBValue( 'description', "select description from host where id=".$spid );
                        system( "./getSmokePingPath ". $spid ." $startTime $endTime > tmp/".$spid.'-'.$startTime.'-'.$endTime.'.name');
                        $file = 'tmp/'.$spid.'-'.$startTime.'-'.$endTime.'.name';
                        $f=fopen($file,'r');
                        $imageFile=fread($f,filesize($file));
                        fclose($f);
                        $handle = fopen($imageFile, "rb");
                        $contents = fread($handle, filesize($imageFile));
                        fclose($handle);
                        unlink('tmp/'.$spid.'-'.$startTime.'-'.$endTime.'.name');
                        unlink($imageFile);
                        return base64_encode($contents);
                    }
                }
                else {
                        return 'Error: SPID is not a number';
                }
            }
            else {
                    return 'Error: nmidSmokeping not enabled';
            }
        }
        else {
                return 'Error: getSmokePingPath not found';
        }
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}

/**
 * getSmokePingConfig
 * @param string $password
 * @param string $server
 * @return string
 */
function getSmokePingConfig( $password, $server )
{
    if ( checkPassword( $password ) )
    {
        if ( preg_match("/nmid_spserver\d/", $server ) > 0 )
        {

            $ourFileName = readConfigOption('nmid_spdir')."smokeping_".$server."_config.txt";
            if ( file_exists($ourFileName) )
            {
                $lines = file($ourFileName);
                $smokepingConfig = '';
                foreach ($lines as $line)
                {
                    $smokepingConfig .= $line;
                }
                return $smokepingConfig;
            }
            else {
                return 'Error: SmokePing Config for server '.$server.' Does not exist.';
            }
        }
        else
        {
            return 'Error: Invalid Server:'.$server;
        }
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}

/**
 * Retrieve the Smokeping UserID
 * @param string $password
 * @return string
 */
function getSmokePingUser ( $password )
{
    if ( checkPassword( $password ) )
    {
        return readConfigOption('nmid_spuser') ;
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}

/**
 * Retrieve the Smokeping Password
 * @param string $password
 * @return string
 */
function getSmokePingPassword ( $password )
{
    if ( checkPassword( $password ) )
    {
        return readConfigOption('nmid_sppwd');
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}

/**
 * Retrieve Smokeping Server URL
 * 
 * @param string $password
 * @param string $server
 * @return string
 */
function getSmokePingServerURL( $password, $server )
{
    if ( checkPassword( $password ) )
    {
        if ( preg_match("/^nmid_spserver\d$/", $server ) > 0 )
        {
            return readConfigOption( $server ) . readConfigOption( 'nmid_spurl' ) ;
        }
        else
        {
            return ('Error: Invalid Server : '.$server);
        }
    }
    else
    {
        return 'Error: Wrong WebService Password';
    }
}



?>
