<?php

/**************************************************************************
User Functions
**************************************************************************/



/**
 * Check if a users has mobile access
 * @param string $s_sessionKey
 * @return boolean 
 */
function isMobileAccessEnabled( $s_sessionKey ) {
    $s_sessionKey = getTextEscaped( $s_sessionKey );
    if  ( isSessionActive( $s_sessionKey )  )
    {
        $i_db_userId = getDBValue('UserId','select UserId from plugin_nmidWebService_Mobile_Sessions where Sessionkey="'.$s_sessionKey.'"');
	// Check if the userid is allowed to access the mobile client
	$b_isMAEnabled = false;
	$i_nmidWebService_realmid = getDBValue('id','select id from plugin_realms where display="NMID - Allow Mobile Client Access"');
	$i_nmidWebService_realmid = $i_nmidWebService_realmid + 100;
	$i_db_realmid = getDBValue('realm_id','select realm_id from user_auth_realm where user_id='.$i_db_userId.' AND realm_id='.$i_nmidWebService_realmid);
	if ( ( $i_db_realmid == $i_nmidWebService_realmid ) && ( strlen  ( $i_db_realmid ) > 0 ) ) {
		if ( isNumber( $i_db_realmid ) ) {
			$b_isMAEnabled = true;
		}
	}
	return $b_isMAEnabled;		
    }
    else {
	return FALSE;
    }
}

/**
 * Check if a users has mobile access
 * 
 * @param string $s_password
 * @return string
 */
function getChallenge( $s_password )
{
    $s_password = getTextEscaped( $s_password );
    // check the webservice password
    if  ( checkPassword( $s_password )  ) {
	$s_challenge = _getChallengeKey();
        return $s_challenge;
    }
    else {
        return "Error: Wrong WebService Password";
    }
}

/**
 * Authenticate users against cacti
 * 
 * @param string $s_password
 * @param string $s_userId
 * @param string $s_userPwd
 * @return string
 */
function authUser ( $s_password,$s_userId,$s_userPwd ) {
    $s_password = getTextEscaped( $s_password );
    $s_userId = strtoupper( getTextEscaped( $s_userId) );
    $s_userPwd = getTextEscaped( $s_userPwd );
    $mobileToken = getDBValue('nmidclient_mobiletoken','select nmidclient_mobiletoken from user_auth where UPPER(username)="'.$s_userId.'"');
    $mobileAuth  = getDBValue('nmidclient_authmethod','select nmidclient_authmethod from user_auth where UPPER(username)="'.$s_userId.'"');
    $s_sessionKey = sha1( time() . $s_userPwd  );
    $s_sessionKey = sha1( $s_sessionKey );
    // check the webservice password
    if  ( checkPassword( $s_password )  ) {
	// check user password against challenge
        $i_db_userId = getDBValue('id','select id from user_auth where UPPER(username)="'.$s_userId.'"');
	$sql = "INSERT INTO `plugin_nmidWebService_Mobile_Sessions` (`UserID`,`Sessionkey`,`lastseen`) VALUES(".$i_db_userId.",'".$s_sessionKey."',".time().")";
	if ( getAuthType( $s_password ) == '1') {  // Local Authenticaction
 		$s_db_userPwd = getDBValue('password','select password from user_auth where id="'.$i_db_userId.'"');
		if ( ($mobileAuthMethod = 'cacti') && ( md5($s_userPwd) ==  $s_db_userPwd ) ) { 
		    mysql_query($sql);
		    return $s_sessionKey;
		} 
		else if ( ($mobileAuthMethod = 'mobiletoken') && ( $s_userPwd == $mobileToken  ) ) {
		    mysql_query($sql);
                    return $s_sessionKey;
		}
		else {
		    return "";
		}
	} 
	else { // other authentication methods. Currently only the mobiletoken method is ok
		if ( ($mobileAuthMethod = 'mobiletoken') && ( $s_userPwd == $mobileToken  ) ) {
		    mysql_query($sql);
                    return $s_sessionKey;
                }
                else {
                    return "";
                }
	}
    }
    else {
        return "";
    }
}

/**
 * Check session key
 *
 * @param string $s_sessionKey
 * @return boolean 
 */
function isSessionActive( $s_sessionKey ) 
{
   $s_sessionKey = getTextEscaped( $s_sessionKey );
   $isActive = getDBValue('isActive','SELECT COUNT(id) as isActive FROM plugin_nmidWebService_Mobile_Sessions WHERE Sessionkey = "'.$s_sessionKey.'"');
   if ( $isActive > 0 ) {
	$sql = "UPDATE `plugin_nmidWebService_Mobile_Sessions` SET lastseen = ".time()." WHERE SessionKey = '".$s_sessionKey."'";
	mysql_query($sql);
	return true;
   }
   return false;
}

/**
 * Add Graph to user favourites
 *
 * @param string $s_sessionKey
 * @param string $s_graphId
 * @return boolean
 */
function addGraphToFavourites( $s_sessionKey, $s_graphId ) 
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
	$s_sessionKey = getTextEscaped( $s_sessionKey );
        $i_db_userId = getDBValue('UserId','select UserId from plugin_nmidWebService_Mobile_Sessions where Sessionkey="'.$s_sessionKey.'"');
	if ( isNumber( $s_graphId ) ) {
	    $sql =  "INSERT INTO `plugin_nmidWebService_Mobile_Favourites` (`UserID`,`graphId`) VALUES(".$i_db_userId.",".$s_graphId.")";
	    return mysql_unbuffered_query($sql);
	}
	else {
	    return false;
	}
    } 
    else {
        return false;
    }
}

/**
 * Remove Graph from favourites
 *
 * @param string $s_sessionKey
 * @param string $s_graphId
 * @return boolean
 */
function delGraphFromFavourites( $s_sessionKey, $s_graphId )
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
        $s_sessionKey = getTextEscaped( $s_sessionKey );
        $i_db_userId = getDBValue('UserId','select UserId from plugin_nmidWebService_Mobile_Sessions where Sessionkey="'.$s_sessionKey.'"');
        if ( isNumber( $s_graphId ) ) {
            $sql =  "DELETE FROM `plugin_nmidWebService_Mobile_Favourites` WHERE UserId = ".$i_db_userId." AND graphId = ".$s_graphId;
            return mysql_unbuffered_query($sql);
        }
        else {
            return false;
        }
    }
    else {
        return false;
    }
}

/**
 * Check if Graph is in favourites
 *
 * @param string $s_sessionKey
 * @param string $s_graphId
 * @return boolean
 */
function isGraphInFavourites( $s_sessionKey, $s_graphId )
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
        $s_sessionKey = getTextEscaped( $s_sessionKey );
        $i_db_userId = getDBValue('UserId','select UserId from plugin_nmidWebService_Mobile_Sessions where Sessionkey="'.$s_sessionKey.'"');
        if ( isNumber( $s_graphId ) ) {
	    $isInFavourites = getDBValue('isInFavourites','SELECT count(graphId) as isInFavourites from plugin_nmidWebService_Mobile_Favourites where graphId = '.$s_graphId);
	    if ( $isInFavourites > 0 ) {
		return true;
	    }
	    return false;
        }
        else {
            return false;
        }
    }
    else {
        return false;
    }
}


/**
 * Get Favourites
 *
 * @param string $s_sessionKey
 * @return string
 */
function getFavourites( $s_sessionKey )
{
    if  ( isSessionActive( $s_sessionKey )  )
    {
        $s_sessionKey = getTextEscaped( $s_sessionKey );
        $i_db_userId = getDBValue('UserId','select UserId from plugin_nmidWebService_Mobile_Sessions where Sessionkey="'.$s_sessionKey.'"');
        $s_FavsList = '';
        $s_query = 'select 	
			graphId
                from
                        plugin_nmidWebService_Mobile_Favourites
                where
                        UserId = '.$i_db_userId.'
		order by graphId';

        $o_result = mysql_query( $s_query );
        while ( $a_row = mysql_fetch_assoc( $o_result ) ) {
		$name = getDBValue("title_cache","select title_cache from graph_templates_graph where local_graph_id= ".$a_row['graphId'].";");
                $s_FavsList = $s_FavsList . $a_row['graphId'].";".$name."\n";
        }

        // Remove the last newline character
        $s_FavsList = preg_replace("/\n$/","",$s_FavsList);

        // Free the result set
        mysql_free_result( $o_result );

        return  $s_FavsList;

    }
    else {
        return "FALSE";
    }
}


/**
 * Get Authentication Type
 * 
 * @param string $s_password
 * @return string
 */
function getAuthType ( $s_password ) {
    if  ( checkPassword( $s_password )  ) {
	$s_authType = readConfigOption( "auth_method" );
	if  ( strlen($s_authType) < 1 ) {
		$s_authType = "1";
	}
	return $s_authType;
    }
    else {
        return "Error: Wrong WebService Password";
    }
}


// Generate default challenge key
// TODO: Let the challenge key be defined via the Cacti WebInterface
function _getChallengeKey() {
    // Generate the Challenge key
    $s_key = "Very Private Challenge Key!"; // change me !
    $s_challenge = substr( strtoupper( md5( $str ) ), 20);
    return $s_challenge;
}

?>
